//this file is part of eMule
//Copyright (C)2002 Merkur ( merkur-@users.sourceforge.net / http://www.emule-project.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#pragma once

#ifdef OLD_SOCKETS_ENABLED
#include "ListenSocket.h"
#endif //OLD_SOCKETS_ENABLED

#include <hash_map>

#ifndef VS2002
using namespace stdext;
#endif

struct SIPFilter
{
   uint32	dwStart;
   uint32	dwEnd;
   UINT		uiLevel;
   CString	strDesc;
#if 0
   UINT		uiHits;
#endif
};

#define	DFLT_IPFILTER_FILENAME	_T("IPFilter.dat")

// 'CArray' would give us more cach hits, but would also be slow in array element creation 
// (because of the implicit ctor in 'SIPFilter'
//typedef CArray<SIPFilter, SIPFilter> CIPFilterArray; 
typedef CTypedPtrArray<CPtrArray, SIPFilter*> CIPFilterArray;

/////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////
class CIPFilter
{
public:
	CIPFilter();
	~CIPFilter();

	void	AddIPRange(uint32 dwIPFrom, uint32 dwIPTo, UINT uiLevel, const CString& rstrDesc);
	void	AddTemporaryBannedIP(uint32 dwIP) { iplist_temporary[dwIP] = ::GetTickCount(); }
	void	RemoveAllIPs();
	void	RemoveOldIPs();
	int		AddFromFile(LPCTSTR pstrFilePath, bool bShowResponse = true);
	int		LoadFromDefaultFile(bool bShowResponse = true);
	BOOL	DownloadIPFilter();

	bool	IsFiltered(uint32 dwIP);
	bool	IsFiltered(uint32 dwIP, UINT uiLevel);
	bool	IsTemporaryFiltered(uint32 dwIP);
	LPCTSTR	GetLastHit() const;

private:
	const SIPFilter*		m_pLastHit;
	CIPFilterArray			m_IPList;
	hash_map<uint32,uint32>	iplist_temporary;
	CString					m_strTemporaryLastHit;

	bool	ParseFilterLine1(const CString& rstrBuffer, uint32& rdwIP1, uint32& rdwIP2, UINT& ruiLevel, CString& rstrDesc) const;
	bool	ParseFilterLine2(const CString& rstrBuffer, uint32& rdwIP1, uint32& rdwIP2, UINT& ruiLevel, CString& rstrDesc) const;
};
/////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////
