// #zegzav:pastcomment

#pragma once
#include "types.h"

enum _EnumPartFileRating
{
	PF_RATING_NONE = 0,
	PF_RATING_FAKE,
	PF_RATING_POOR,
	PF_RATING_GOOD,			//Fair and Good are reversed for some reason
	PF_RATING_FAIR,
	PF_RATING_EXCELLENT,
};
typedef EnumDomain<_EnumPartFileRating>		EnumPartFileRating;

class CPastComment
{
	public:
		CPastComment();
		CPastComment(uchar client[16]);
		CPastComment(uchar client[16], const CString &strClientName);
		CPastComment( uchar client[16], const CString &strClientName, const CString &strFileName,
					  const CString &strComment, EnumPartFileRating eRating );
		~CPastComment();

		const CString &GetClientName() const;
		void SetFileName(const CString &strFileName);
		const CString &GetFileName() const;
		void SetComment(const CString &strComment);
		const CString &GetComment() const;
		void SetRating(EnumPartFileRating eRating);
		EnumPartFileRating GetRating() const;

		bool operator==(const CPastComment &pc) const;

	protected:
		uchar				m_ClientHash[16];
		CString				m_strClientName;
		CString				m_strFileName;
		CString				m_strComment;
		EnumPartFileRating	m_eRating;
};

#ifndef NEW_SOCKETS_TRAY
class CPastCommentList : public CList<CPastComment, CPastComment&>
{
	public:
		CPastCommentList();
		~CPastCommentList();

		void Add(uchar client[16], const CString &strClientName, const CString &strFileName, const CString &strComment, EnumPartFileRating eRating);
		void Remove(uchar client[16]);
		int GetCount() const;

		bool GetCommentRating(uchar client[16], CString *pstrComment, EnumPartFileRating *peRating) const;
		const CString &GetFileName(uchar client[16]);
		const CString &GetComment(uchar client[16]);
		byte GetRate(uchar client[16]);

	protected:
		// POSITION Find(uchar client[16]) const;
};
#endif //NEW_SOCKETS_TRAY


inline CPastComment::~CPastComment()
{
}

inline const CString &CPastComment::GetClientName() const
{
	return m_strClientName;
}

inline void CPastComment::SetComment(const CString &strComment)
{
	m_strComment= strComment;
}

inline const CString &CPastComment::GetComment() const
{ 
	return m_strComment; 
}

inline void CPastComment::SetFileName(const CString &strFileName)
{
	m_strFileName= strFileName;
}

inline const CString &CPastComment::GetFileName() const
{ 
	return m_strFileName; 
}

inline void CPastComment::SetRating(EnumPartFileRating eRating)
{ 
	m_eRating = eRating; 
}

inline EnumPartFileRating CPastComment::GetRating() const
{ 
	return m_eRating;
}

#ifndef NEW_SOCKETS_TRAY
inline CPastCommentList::CPastCommentList()
{
}

inline CPastCommentList::~CPastCommentList()
{
}
#endif //NEW_SOCKETS_TRAY