//this file is part of eMule
//Copyright (C)2002 Merkur ( merkur-@users.sourceforge.net / http://www.emule-project.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


// TransferWnd.cpp : implementation file
//

#include "stdafx.h"
#include "emule.h"
#include "TransferWnd.h"
#include "otherfunctions.h"
#include "AddBuddy.h"
#include "CatDialog.h"
#include "IP2Country.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

#define TRANS_ROLLUP		120
#define TRANS_DOWNLOADLIST	121
#define TRANS_UPLOADLIST	122
#define TRANS_QUEUELIST		123
#define TRANS_INFOLIST		124
#define TRANS_DOWNLOADTABS	125
#define TRANS_TABWINDOW		126
#define TRANS_CLIENTLIST	127
#define TRANS_DUMMY			130


///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
class CDummyForTabs : public CWnd
{
public:
	CDummyForTabs(){ m_pChild = NULL; }

	void SetChild(CWnd* pChild){ m_pChild = pChild;	}

	CWnd* GetChild(){ return m_pChild; }

	virtual BOOL OnNotify(WPARAM wParam, LPARAM lParam, LRESULT* pResult)
	{
		EMULE_TRY
		NMHDR* pNMHDR = (NMHDR*)lParam;
		switch(pNMHDR->code)
		{
		case LVN_ITEMACTIVATE:
		case LVN_COLUMNCLICK:
		case NM_CLICK:
		case NM_DBLCLK:
			break;
		default:
			*pResult = GetParent()->GetParent()->SendMessage(WM_NOTIFY, wParam, lParam);
			return TRUE;
		}
		EMULE_CATCH2
		return CWnd::OnNotify(wParam, lParam, pResult);
	}


	afx_msg void OnSize(uInt nType, int cx, int cy)
	{
		EMULE_TRY
		if(m_pChild)
		{
			CRect r;
			GetClientRect(&r);
			r -= CSize(2,2);
			m_pChild->SetWindowPos(NULL, 0,0, r.Width(), r.Height(), SWP_NOMOVE|SWP_NOZORDER);
		}
		EMULE_CATCH2
	}

	DECLARE_DYNCREATE(CDummyForTabs)
	DECLARE_MESSAGE_MAP()

private:
	CWnd* m_pChild;
};
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CCatTabs::DrawItem(CDC *pDC, int iItem)
{
#define COLORBARHEIGHT	2
#define TRIANGLESIZE	12
//#define TRIANGLESIZE	((rItem.bottom-rItem.top+1)/2)
	CTabs::DrawItem(pDC,iItem);

//	Draw the category color bar for user categories.
	if (iItem >= CCat::GetNumPredefinedCats() && iItem < CCat::GetNumCats())
	{
		CRect		rItem;
		CRect		rClient;
		COLORREF	cr;

		GetClientRect(rClient);
		GetItemRect(iItem, rItem);
#ifdef USE_BAR
#ifndef NEW_LOOK
		rItem.top = rClient.top;
		rItem.bottom = rItem.top + COLORBARHEIGHT;
		cr = CCat::GetCatColorByIndex(iItem);
		pDC->FillSolidRect(&rItem,cr);
#else
		if (iItem == GetCurSel())
		{
			rItem.top = rClient.top;
		}
		rItem.top++;
		rItem.bottom = rItem.top + COLORBARHEIGHT;
		cr = CCat::GetCatColorByIndex(iItem);

		CPen		*pOldPen,barPen;

		barPen.CreatePen(PS_SOLID,0,cr);
		pOldPen = pDC->SelectObject(&barPen);
		pDC->MoveTo(rItem.left+1,rItem.top);
		pDC->LineTo(rItem.right-1,rItem.top);
		pDC->MoveTo(rItem.left,rItem.top+1);
		pDC->LineTo(rItem.right,rItem.top+1);
		pDC->SelectObject(pOldPen);
//		pDC->FillSolidRect(&rItem,cr);
#endif NEW_LOOK

#else
		CBrush		*pOldBrush, newBrush;

		cr = CCat::GetCatColorByIndex(iItem);
		newBrush.CreateSolidBrush(cr);
		pOldBrush = pDC->SelectObject(&newBrush);
		rItem.top = rClient.top;
		pDC->BeginPath();
		pDC->MoveTo(rItem.left + 2, rItem.top + 1);
		pDC->LineTo(rItem.left + 2 + TRIANGLESIZE, rItem.top + 1);
		pDC->LineTo(rItem.left + 2, rItem.top + 1 + TRIANGLESIZE);
		pDC->EndPath();
		pDC->FillPath();
		pDC->SelectObject(pOldBrush);
#endif USE_BAR
	}
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

IMPLEMENT_DYNAMIC(CDummyForTabs, CWnd)

BEGIN_MESSAGE_MAP(CDummyForTabs, CWnd)
	ON_WM_SIZE()
END_MESSAGE_MAP()

BEGIN_MESSAGE_MAP(CTransferWnd, CResizableDialog)
	ON_WM_DESTROY()	// eklmn: bugfix(00): resource cleanup due to CResizableDialog
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEMOVE()

//	ON_NOTIFY(TCN_SELCHANGE, TRANS_DOWNLOADTABS, OnTcnSelchangeDltab)
//	ON_NOTIFY(NM_RCLICK, TRANS_DOWNLOADTABS, OnNMRClickDltab)
//	ON_NOTIFY(NM_TABMOVED, TRANS_DOWNLOADTABS, OnTabMovement)
// ON_NOTIFY(LVN_BEGINDRAG, TRANS_DOWNLOADLIST, OnLvnBeginDrag)

	ON_WM_LBUTTONDBLCLK()
END_MESSAGE_MAP()

// CTransferWnd dialog

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
IMPLEMENT_DYNAMIC(CTransferWnd, CDialog)
CTransferWnd::CTransferWnd(CWnd* pParent /*=NULL*/)
	: CResizableDialog(CTransferWnd::IDD, pParent)
{
	m_bIsDragging = false;
	m_pwndDummyForDownloadList = NULL;

	m_pLastMousePoint.x = 0;
	m_pLastMousePoint.y = 0;

	m_iOldToolTipItemDownload = -1;
	m_iOldToolTipItemUpload = -1;
	m_iOldToolTipItemQueue = -1;
	m_iOldToolTipItemClients = -1;	
	m_nLastCatTT = -1;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
CTransferWnd::~CTransferWnd()
{
	SaveRollupItemHeights();
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
BOOL CTransferWnd::OnInitDialog()
{
	EMULE_TRY

	CResizableDialog::OnInitDialog();
	m_bFirstShow = true;
	//Localize();

	//	Create the Rollup control
	CRect		rRollupArea;

	GetClientRect(&rRollupArea);
	rRollupArea.DeflateRect(8, 5);

	m_ctlRollup.Create(NULL, NULL, WS_CHILD|WS_VISIBLE/*|WS_CLIPCHILDREN*/, rRollupArea, this, TRANS_ROLLUP);

	//
	//	Create the Download-list control
	//
	CWnd		*pParent = &m_ctlRollup;
	CRect		rItem = CRect(0, 0, 0, 0);
	DWORD		dwListStyle = WS_CHILD|WS_BORDER|WS_TABSTOP|LVS_REPORT|LVS_ALIGNLEFT|LVS_OWNERDRAWFIXED|LVS_SINGLESEL;
	DWORD		dwTabStyle = WS_CHILD|WS_VISIBLE|TCS_HOTTRACK|TCS_SINGLELINE|TCS_TOOLTIPS;

	m_pwndDummyForDownloadList = new CDummyForTabs();
	m_pwndDummyForDownloadList->Create(AfxRegisterWndClass(0), "", WS_CHILD|WS_VISIBLE, rItem, pParent, TRANS_DUMMY);

	m_ctlDownloadList.Create(WS_VISIBLE | dwListStyle, rItem, m_pwndDummyForDownloadList, TRANS_DOWNLOADLIST);

	g_App.m_pDownloadList->SetDownloadListCtrl(&m_ctlDownloadList);
	m_ctlUploadList.Create(WS_VISIBLE | dwListStyle, rItem, pParent, TRANS_UPLOADLIST);
	m_ctlQueueList.Create(/*WS_VISIBLE |*/ dwListStyle, rItem, pParent, TRANS_QUEUELIST);
	m_ctlClientList.Create(/*WS_VISIBLE |*/ dwListStyle, rItem, pParent, TRANS_CLIENTLIST);

	g_App.m_pClientList->SetClientListCtrl(&m_ctlClientList);

	m_ctlInfoList.Create(WS_VISIBLE|WS_CHILD|WS_BORDER|WS_TABSTOP|LVS_REPORT|
							LVS_ALIGNLEFT|LVS_SINGLESEL, rItem, pParent, TRANS_INFOLIST);

	m_ctlDLTabs.Create(dwTabStyle, CRect(0, 0, 0, 20), pParent, TRANS_DOWNLOADTABS);
	m_ctlDLTabs.ModifyStyle(WS_CLIPSIBLINGS, 0);
	m_ctlDLTabs.SendMessage(WM_SETFONT, (WPARAM)GetStockObject(ANSI_VAR_FONT));
	m_ctlDLTabs.SetPadding(CSize(16, 0));

	m_pwndDummyForDownloadList->SetChild(&m_ctlDownloadList);

	AddBuddy(m_pwndDummyForDownloadList->m_hWnd, m_ctlDLTabs.m_hWnd, BDS_TOP);

	CString		strTmp;

	strTmp.Format(GetResString(IDS_RUP_DOWNINFO), g_App.m_pDownloadQueue->GetFileCount(),
						g_App.m_pDownloadQueue->GetActiveFileCount(),
						g_App.m_pDownloadQueue->GetPausedFileCount(),
						g_App.m_pDownloadQueue->GetStoppedFileCount(),
						g_App.m_pDownloadQueue->GetTransferringFiles(),
						static_cast<double>(g_App.m_pDownloadQueue->GetDataRate()) / 1024.0);
	m_ctlRollup.InsertItem(GetResString(IDS_RUP_DOWNLOADS), strTmp, m_pwndDummyForDownloadList, 0, TRUE);

	strTmp.Format(GetResString(IDS_RUP_UPINFO), g_App.m_pUploadQueue->GetWaitingUserCount(),
					  g_App.m_pUploadQueue->GetUploadQueueLength(),
					  g_App.m_pUploadQueue->GetBanCount(),
					  static_cast<double>(g_App.m_pUploadQueue->GetDataRate()) / 1024.0);
	m_ctlRollup.InsertItem(GetResString(IDS_RUP_UPLOADS), strTmp, &m_ctlUploadList, 1, TRUE);
	m_ctlRollup.InsertItem(GetResString(IDS_RUP_INFO), _T(""), &m_ctlInfoList, 2, FALSE);

	AddAnchor(m_ctlRollup.m_hWnd, TOP_LEFT, BOTTOM_RIGHT);

	InitRollupItemHeights();

	m_ctlDownloadList.Init();
	m_ctlUploadList.Init();
	m_ctlQueueList.Init();
	m_ctlClientList.Init();

	m_ctlDownloadList.SetOwner(this);
	m_ctlUploadList.SetOwner(this);
	m_ctlQueueList.SetOwner(this);
	m_ctlClientList.SetOwner(this);
	m_ctlDLTabs.SetOwner(this);

	m_nActiveWnd = MPW_UPLOADLIST;
	m_iTabRightClickIndex = -1;

	//	Initialize the Category tabs
	for (int ix = 0; ix < CCat::GetNumCats(); ix++)
		m_ctlDLTabs.InsertItem(ix,CCat::GetCatByIndex(ix)->GetTitle());

	// List controls & Category tabs tooltips
	m_ttip.Create(this);
	m_ttip.SetDelayTime(TTDT_AUTOPOP, 15000);
	m_ttip.SetDelayTime(TTDT_INITIAL, g_App.m_pPrefs->GetToolTipDelay()*1000);
	m_ttip.SendMessage(TTM_SETMAXTIPWIDTH, 0, SHRT_MAX);
	m_ttip.SetBehaviour(PPTOOLTIP_MULTIPLE_SHOW);
	m_ttip.SetNotify(m_hWnd);
	m_ttip.AddTool(&m_ctlDownloadList, _T(""));
	m_ttip.AddTool(&m_ctlUploadList, _T(""));
	m_ttip.AddTool(&m_ctlQueueList, _T(""));
	m_ttip.AddTool(&m_ctlClientList, _T(""));
	m_ttip.AddTool(&m_ctlDLTabs, _T(""));
//	m_ttip.SetFont(_T("Courier"), 9);

	EMULE_CATCH

	return true;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// v- eklmn: bugfix(00): resource cleanup due to CResizableDialog
void CTransferWnd::OnDestroy()
{
	if(m_pwndDummyForDownloadList)
	{
		m_pwndDummyForDownloadList->DestroyWindow();
		delete m_pwndDummyForDownloadList;
	}
	CResizableDialog::OnDestroy();
}

// ^- eklmn: bugfix(00): resource cleanup due to CResizableDialog
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CTransferWnd::DoDataExchange(CDataExchange* pDX)
{
	CResizableDialog::DoDataExchange(pDX);
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// CTransferWnd message handlers
BOOL CTransferWnd::PreTranslateMessage(MSG* pMsg)
{
	if (g_App.m_pPrefs->GetToolTipDelay() != 0)
	{
		switch (pMsg->message)
		{
			case WM_LBUTTONDOWN:
			case WM_LBUTTONUP:
			case WM_RBUTTONDOWN:
			case WM_RBUTTONUP:
			case WM_MOUSEMOVE:
			case WM_MOUSEWHEEL:
			case WM_KEYDOWN:
			case WM_SYSKEYDOWN:
				m_ttip.RelayEvent(pMsg);
		}
		if (pMsg->message == WM_MOUSEMOVE || pMsg->message == WM_MOUSEWHEEL)
		{
			CPoint	point;

			::GetCursorPos(&point);

			if ((point.x != m_pLastMousePoint.x) || (point.y != m_pLastMousePoint.y))
			{
				m_pLastMousePoint = point;

				//	Handle tooltip updating, when mouse is moved from one item to another
				UpdateToolTips();
			}
		}
	}

	if (pMsg->message == WM_LBUTTONDBLCLK && pMsg->hwnd == m_ctlDLTabs.GetSafeHwnd())
	{
		POINT point;

		::GetCursorPos(&point);

		CPoint pt(point);

		if (GetTabUnderMouse(&pt) != -1)
		{
			OnDblClickDltab();
			return TRUE;
		}
	}

	if (pMsg->message == WM_MBUTTONUP) 
	{
	//	If we are in Download list, display user or file details
		int iSel = GetItemUnderMouse(&m_ctlDownloadList);

		if (iSel != -1)
		{
			m_ctlDownloadList.ShowSelectedFileOrUserDetails();
		}
		else 
		{
			switch (m_nActiveWnd)
			{
				case MPW_UPLOADQUEUELIST:
				{
					m_ctlQueueList.ShowSelectedUserDetails();
					break;
				}
				case MPW_UPLOADLIST:
				{
					m_ctlUploadList.ShowSelectedUserDetails();
					break;
				}
				case MPW_UPLOADCLIENTLIST:
				{
					m_ctlClientList.ShowSelectedUserDetails();
					break;
				}
			}
		}
		return TRUE;
	}

	if(pMsg->message == USRMSG_SWITCHUPLOADLIST)
		SwitchUploadList();

	return CResizableDialog::PreTranslateMessage(pMsg);
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CTransferWnd::UpdateToolTips(void)
{
	EMULE_TRY

	// Update tooltips for Category tabs
	CPoint		point;
	bool		bPop = true;

	::GetCursorPos(&point);

	int iSel = GetTabUnderMouse(&point);

	if (iSel != -1)
	{
		bPop = false;
		if (iSel != m_nLastCatTT)
		{
			if (m_ttip.IsWindowVisible())
				m_ttip.UpdateData();
			m_nLastCatTT = iSel;
			return;
		}
	}

	// Update tooltips for Download List
	CListCtrl	*pListCtrl = &m_ctlDownloadList;

	iSel = GetItemUnderMouse(pListCtrl);	
	if (iSel != -1)
	{
		bPop = false;
		if (iSel != m_iOldToolTipItemDownload) 
		{
			if (m_ttip.IsWindowVisible())
				m_ttip.UpdateData();
			m_iOldToolTipItemDownload = iSel;
			return;
		}
	}

	//	Update tooltips for Upload List
	pListCtrl = &m_ctlUploadList;
	iSel = GetItemUnderMouse(pListCtrl);
	if (iSel != -1)
	{
		bPop = false;
		if (iSel != m_iOldToolTipItemUpload)
		{
			if (m_ttip.IsWindowVisible())
				m_ttip.UpdateData();
			m_iOldToolTipItemUpload = iSel;
			return;
		}
	}

	//	Update tooltips for Queue List
	pListCtrl = &m_ctlQueueList;
	iSel = GetItemUnderMouse(pListCtrl);
	if (iSel != -1)
	{
		bPop = false;
		if (iSel != m_iOldToolTipItemQueue)
		{
			if (m_ttip.IsWindowVisible())
				m_ttip.UpdateData();
			m_iOldToolTipItemQueue = iSel;
			return;
		}
	}

	//	Update tooltips for Clients List
	pListCtrl = &m_ctlClientList;
	iSel = GetItemUnderMouse(pListCtrl);
	if (iSel != -1)
	{
		bPop = false;
		if (iSel != m_iOldToolTipItemClients)
		{
			if (m_ttip.IsWindowVisible())
				m_ttip.UpdateData();
			m_iOldToolTipItemClients = iSel;
			return;
		}
	}

	if (bPop)
		m_ttip.Pop();

	EMULE_CATCH
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void  CTransferWnd::GetInfo4ToolTip(NM_PPTOOLTIP_DISPLAY *pNotify)
{
	EMULE_TRY

	int						iControlId = CWnd::FromHandle(pNotify->ti->hWnd)->GetDlgCtrlID();

	if (iControlId == NULL)
		return;

	CString strInfo;

	switch (iControlId)
	{
		case TRANS_DOWNLOADTABS:
		{
			int			iIndex = GetTabUnderMouse(&CPoint(*pNotify->pt));

			if (iIndex < 0)
				return;

			uint16		iCount = 0, iTransferring = 0, iPaused = 0, iStopped = 0;
			double		dblSpeed = 0.0;
			uint64		iSize = 0, iCompletedSize = 0, iRealSize = 0;
			CPartFile	*pPartFile;
			CString		strCatTitle;
			CCat		*pCat = CCat::GetCatByIndex(iIndex);

			if (iIndex != 0 || CCat::GetAllCatType() == CAT_ALL)
				strCatTitle = pCat->GetTitle();
			else
				strCatTitle = _T("[") + CCat::GetPredefinedCatTitle(CCat::GetAllCatType()) + _T("]");

			if (pCat->GetID() < CAT_PREDEFINED)
			{
				strInfo.Format(_T("<cat=0x%06x>"), CCat::GetCatColorByIndex(iIndex));
			}

			for (int i = 0; i < g_App.m_pDownloadQueue->GetFileCount(); i++)
			{
				pPartFile = g_App.m_pDownloadQueue->GetFileByIndex(i);

				if (pPartFile != NULL)
				{
					if (CCat::FileBelongsToGivenCat(pPartFile, CCat::GetCatIDByIndex(iIndex)))
					{
						iCount++;
						if (pPartFile->GetTransferringSrcCount() > 0)
							iTransferring++;
						if (pPartFile->IsPaused() && !pPartFile->IsStopped())
							iPaused++;
						if (pPartFile->IsStopped())
							iStopped++;
						dblSpeed += pPartFile->GetDataRate() / 1024.0f;
						iSize += pPartFile->GetFileSize();
						iCompletedSize += pPartFile->GetCompletedSize();
						iRealSize += pPartFile->GetRealFileSize();
					}
				}
			}

			if (!pCat->GetComment().IsEmpty())
			{
				strCatTitle += _T(" (");
				strCatTitle += pCat->GetComment();
				strCatTitle += _T(")");
			}
			strCatTitle.Replace(_T("\n"), _T("<br>"));
			strCatTitle.Replace(_T("<"), _T("<<"));

			strInfo.AppendFormat(_T("<b>%s</b><br><hr=100%%><br><b>%s:</b><t>%i / %i<br><b>%s:</b><t>%i<br><b>%s:</b><t>%i<br><b>%s:</b><t>%.1f %s<br><b>%s:</b><t>%s / %s<br><b>%s:</b><t>%s<br><b>%s</b><t>%s<br><b>%s</b><t>%s"),
				strCatTitle,
				GetResString(IDS_DOWNLOADING), iTransferring, (iCount - iPaused - iStopped),
				GetResString(IDS_PAUSED), iPaused, GetResString(IDS_STOPPED), iStopped,
				GetResString(IDS_DL_SPEED), dblSpeed, GetResString(IDS_KBYTESEC),
				GetResString(IDS_DL_SIZE), CastItoXBytes(iCompletedSize), CastItoXBytes(iSize),
				GetResString(IDS_SIZE_ON_DISK), CastItoXBytes(iRealSize),
				GetResString(IDS_PW_INCOMING), pCat->GetPath(),
				GetResString(IDS_PW_TEMP), pCat->GetTempPath());
			
			break;
		}
		case TRANS_DOWNLOADLIST:
		{
			if (m_ctlDownloadList.GetItemCount() < 1)
				return;

			int		iSel = GetItemUnderMouse(&m_ctlDownloadList);

			if (iSel < 0 || iSel == 65535)
				return;

			//	Build info text and display it
			CMuleCtrlItem		*pItem = reinterpret_cast<CMuleCtrlItem*>(m_ctlDownloadList.GetItemData(iSel));
			CPartFileDLItem		*pPartFileItem = dynamic_cast<CPartFileDLItem*>(pItem);
			CSourceDLItem		*pSourceItem = dynamic_cast<CSourceDLItem*>(pItem);

			if (pPartFileItem != NULL)
			{
				CPartFile		*pPartFile = pPartFileItem->GetFile();
				SHFILEINFO		shfi;

				strInfo = pPartFile->GetDownloadFileInfo4Tooltips();
				memzero(&shfi, sizeof(shfi));
				SHGetFileInfo(pPartFile->GetFileName(),	FILE_ATTRIBUTE_NORMAL, &shfi, sizeof(shfi),	SHGFI_ICON | SHGFI_USEFILEATTRIBUTES);
				pNotify->ti->hIcon = shfi.hIcon;
			}
			else if (pSourceItem != NULL)
			{
#ifdef OLD_SOCKETS_ENABLED
				bool				bA4AF = pSourceItem->IsAskedForAnotherFile();
				CUpDownClient	    *pSource = pSourceItem->GetSource();
				CString				strTmp, strUserName = pSource->GetUserName();

				strUserName.Trim();
				strUserName.Replace(_T("\n"), _T("<br>"));
				strUserName.Replace(_T("<"), _T("<<"));

				if (g_App.m_pIP2Country->IsIP2Country())
					strTmp.Format(_T(" (<b>%s</b>)"), pSource->GetCountryName());

				strInfo.Format(_T("<t=1><b>%s</b><br><t=1>%s: %u%s<br><hr=100%%><br><b>%s:<t></b>%s:%u (<b>%s</b>)"),
					strUserName, GetResString(IDS_USERID), pSource->GetUserID(), strTmp,
					GetResString(IDS_CLIENT), pSource->GetFullIP(), pSource->GetUserPort(), pSource->GetFullSoftVersionString());

				CServer *pServer = g_App.m_pServerList->GetServerByIP(pSource->GetServerIP(), pSource->GetServerPort());

				if (pServer != NULL)
				{
					in_addr			serverAddr;

					strTmp = pServer->GetListName();
					serverAddr.S_un.S_addr = pSource->GetServerIP();
					strInfo.AppendFormat(_T("<br><b>%s:<t></b>%s:%d"), GetResString(IDS_SERVER), inet_ntoa(serverAddr), pSource->GetServerPort());

					strTmp.Replace(_T("<"), _T("<<"));
					strTmp.Replace(_T("\n"), _T("<br>"));
					if (!strTmp.IsEmpty())
					{
						strInfo += _T(" (<b>");
						strInfo += strTmp;
						strInfo += _T("</b>)");
					}
				}
				
				if (pSource->Credits() != NULL && pSource->Credits()->GetUploadedTotal() != pSource->GetTransferredUp())
					strInfo.AppendFormat(_T("<br><b>%s:</b><t>%s (%s)"), GetResString(IDS_STATS_DDATA), CastItoXBytes(pSource->GetTransferredUp()), CastItoXBytes(pSource->Credits()->GetUploadedTotal()));
				else if (pSource->GetTransferredUp() > 0)
					strInfo.AppendFormat(_T("<br><b>%s:</b><t>%s"), GetResString(IDS_STATS_DDATA), CastItoXBytes(pSource->GetTransferredUp()));

				if (pSource->Credits() != NULL && pSource->Credits()->GetDownloadedTotal() != pSource->GetTransferredDown())
					strInfo.AppendFormat(_T("<br><b>%s:</b><t>%s (%s)"), GetResString(IDS_STATS_UDATA), CastItoXBytes(pSource->GetTransferredDown()), CastItoXBytes(pSource->Credits()->GetDownloadedTotal()));
				else if (pSource->GetTransferredDown() > 0)
					strInfo.AppendFormat(_T("<br><b>%s:</b><t>%s"), GetResString(IDS_STATS_UDATA), CastItoXBytes(pSource->GetTransferredDown()));

				strInfo.AppendFormat(_T("<br><b>%s:<t></b>%d"),	GetResString(IDS_TT_ASKEDCOUNT), pSource->GetAskedCountDown());

				if ((pSource->GetDownloadState() == DS_ONQUEUE) || (pSource->GetDownloadState() == DS_NONEEDEDPARTS))
				{
					if (pSource->IsUDPFileReqPending())
						strInfo.AppendFormat(_T("<br><b>%s:<t></b>%s"), GetResString(IDS_NEXT_ASK), GetResString(IDS_ASKING));
					else
					{
						uint32 	dwFileReaskTime = pSource->GetNextFileReaskTime();
						uint32 	dwCurTick = ::GetTickCount();

						if (dwCurTick <= dwFileReaskTime)
							strInfo.AppendFormat(_T("<br><b>%s:<t></b>%s"), GetResString(IDS_NEXT_ASK), CastSecondsToHM((dwFileReaskTime - dwCurTick) / 1000));
					}
				}

				strInfo.AppendFormat(_T("<br><b>%s:<t></b>%d"),	GetResString(IDS_TT_AVAILABLEPARTS), pSource->GetAvailablePartCount());

				if (!bA4AF)
				{
					if (!pSource->IsClientFilenameEmpty())
						strInfo.AppendFormat(_T("<br><b>%s:<t></b>%s"), GetResString(IDS_TT_CLIENTSOURCENAME), pSource->GetClientFilename());
				}
				//	If Asked For Another File...
				else
				{
					//	Cax2- get local file name
					try
					{
						strInfo.AppendFormat(_T("<br><b>%s:<t></b>%s"), GetResString(IDS_ASKED4ANOTHERFILE), pSource->m_pReqPartFile->GetFileName());
					}
					catch(...)
					{
					}
				}
				//-For File Comment-//
				try
				{
					if (!bA4AF)
					{
						if (!pSource->IsFileCommentEmpty())
							strInfo.AppendFormat(_T("<br><hr=100%%><br><b>%s</b><t>%s<br>"), GetResString(IDS_CMT_READ), pSource->GetFileComment());
						else
							strInfo.AppendFormat(_T("<br><hr=100%%><br>%s<br>"), GetResString(IDS_CMT_NONE));

						if (GetRatingString(pSource->GetFileRating()) == GetResString(IDS_CMT_NOTRATED))
							strInfo += GetResString(IDS_CMT_NOTRATED);
						else
							strInfo.AppendFormat(_T("<b>%s:</b><t>%s"), GetResString(IDS_TT_CMT_RATING), GetRatingString(pSource->GetFileRating()));
					}
				}
				catch(...)
				{
					//Information not received = not connected or connecting
					strInfo.AppendFormat(_T("<br><hr=100%%><br>%s"), GetResString(IDS_CMT_NOTCONNECTED));
				}
				//-End file comment-//

			// Set the tooltip icon
				pNotify->ti->hIcon =
					g_App.m_pMDlg->m_clientImgLists[CLIENT_IMGLST_PLAIN].ExtractIcon(pSource->GetClientIconIndex());
#endif //OLD_SOCKETS_ENABLED
			}
			break;
		}
		case TRANS_UPLOADLIST:
		{
			if (m_ctlUploadList.GetItemCount() < 1)
				return;

			int		iSel = GetItemUnderMouse(&m_ctlUploadList);

			if (iSel < 0 || iSel == 65535)
				return;

			CUpDownClient *pSource = (CUpDownClient*)m_ctlUploadList.GetItemData(iSel);

			pNotify->ti->hIcon = pSource->GetClientInfo4Tooltips(strInfo, true);
			break;
		}
		case TRANS_QUEUELIST:
		{
			if (m_ctlQueueList.GetItemCount() < 1)
				return;

			int		iSel = GetItemUnderMouse(&m_ctlQueueList);

			if (iSel < 0 || iSel == 65535)
				return;

			CUpDownClient *pSource = (CUpDownClient*)m_ctlQueueList.GetItemData(iSel);

			pNotify->ti->hIcon = pSource->GetClientInfo4Tooltips(strInfo);
			break;
		}
		case TRANS_CLIENTLIST:
		{
			if (m_ctlClientList.GetItemCount() < 1)
				return;

			int		iSel = GetItemUnderMouse(&m_ctlClientList);

			if (iSel < 0 || iSel == 65535)
				return;

			CUpDownClient *pSource = (CUpDownClient*)m_ctlClientList.GetItemData(iSel);

			pNotify->ti->hIcon = pSource->GetClientInfo4Tooltips(strInfo);
			break;
		}
	}

	pNotify->ti->sTooltip = strInfo;

	EMULE_CATCH
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//	SwitchUploadList() toggles the visibility of the UploadList with the UploadQueueList
void CTransferWnd::SwitchUploadList()
{
	EMULE_TRY

	switch (m_nActiveWnd)
	{
		case MPW_UPLOADLIST:
		{
			m_nActiveWnd = MPW_UPLOADQUEUELIST;
			m_ctlRollup.SetText(1, GetResString(IDS_ONQUEUE), true);
			m_ctlUploadList.ShowWindow(SW_HIDE);
			m_ctlClientList.ShowWindow(SW_HIDE);
			m_ctlRollup.SetItemClient(1, &m_ctlQueueList);
			m_ctlRollup.Invalidate();
			UpdateQueueFilter();
			break;
		}
		case MPW_UPLOADQUEUELIST:
		{
			m_nActiveWnd = MPW_UPLOADCLIENTLIST;
			UpdateKnown();
			m_ctlUploadList.ShowWindow(SW_HIDE);
			m_ctlQueueList.ShowWindow(SW_HIDE);
			m_ctlRollup.SetItemClient(1, &m_ctlClientList);
			m_ctlRollup.Invalidate();
			break;
		}
		case MPW_UPLOADCLIENTLIST:
		{
			m_nActiveWnd = MPW_UPLOADLIST;
			m_ctlRollup.SetText(1, GetResString(IDS_RUP_UPLOADS), true);
			m_ctlQueueList.ShowWindow(SW_HIDE);
			m_ctlClientList.ShowWindow(SW_HIDE);
			m_ctlRollup.SetItemClient(1, &m_ctlUploadList);
			m_ctlRollup.Invalidate();
			break;
		}
		default:
			break;
	}

	EMULE_CATCH
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//	Update Known Clients on header when total number of known clients changed
void CTransferWnd::UpdateKnown()
{
	if(m_nActiveWnd == MPW_UPLOADCLIENTLIST)
	{
		CString	strBuf = GetResString(IDS_CLIENTLIST);

		strBuf.AppendFormat(" (%u)", m_ctlClientList.GetItemCount());
		m_ctlRollup.SetText(1, strBuf, true);
	}
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//	Update Applied Filter on header when filter changes (triggered in QueueListCtrl)
void CTransferWnd::UpdateQueueFilter()
{
	static const uint16 auResStr[] = {
		IDS_BANNED,		//CLI_FILTER_BANNED
		IDS_FRIENDS,	//CLI_FILTER_FRIEND
		IDS_WITHCREDITS	//CLI_FILTER_CREDIT
	};

	if (m_nActiveWnd == MPW_UPLOADQUEUELIST)
	{
		CString	strBuffer = GetResString(IDS_ONQUEUE);

		if (static_cast<unsigned>(m_ctlQueueList.m_iClientFilter - CLI_FILTER_BANNED) < ELEMENT_COUNT(auResStr))
			strBuffer.AppendFormat(_T(" (%s)"), GetResString(auResStr[m_ctlQueueList.m_iClientFilter - CLI_FILTER_BANNED]));

		m_ctlRollup.SetText(1, strBuffer, true);
	}
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//	Localize() loads localized text for the UI resources
void CTransferWnd::Localize()
{
	EMULE_TRY

	switch(m_nActiveWnd)
	{
		case MPW_UPLOADLIST:
			m_ctlRollup.SetText(1,GetResString(IDS_RUP_UPLOADS), true);
			break;
		case MPW_UPLOADQUEUELIST:
			UpdateQueueFilter();
			break;
		case MPW_UPLOADCLIENTLIST:
			UpdateKnown();
			break;
	}

	//Cax2 - localize the rollup control
	m_ctlRollup.SetText(0,GetResString(IDS_RUP_DOWNLOADS), true);
	m_ctlRollup.SetText(2,GetResString(IDS_RUP_INFO), true);
	if (m_bFirstShow)
	{
		m_bFirstShow = false;
		m_ctlInfoList.SetColumn(g_App.m_pPrefs->GetDetailColumnWidth());
	}

	m_ctlDownloadList.Localize();
	m_ctlUploadList.Localize();
	m_ctlQueueList.Localize();
	m_ctlClientList.Localize();
	m_ctlInfoList.Localize();

	CString  strCatTitle;

	for (byte i = 0; i < CCat::GetNumPredefinedCats(); i++)
	{
		if (i == 0)
		{
			_EnumCategories eCatID = CCat::GetAllCatType();

			strCatTitle = CCat::GetPredefinedCatTitle(eCatID);
			if (eCatID != CAT_ALL)
			{
				strCatTitle = _T('[') + strCatTitle;
				strCatTitle += _T(']');
			}
			CCat::GetCatByIndex(i)->SetTitle(GetResString(IDS_CAT_ALL));
		}
		else
		{
			strCatTitle = CCat::GetPredefinedCatTitle(CCat::GetCatIDByIndex(i));
			CCat::GetCatByIndex(i)->SetTitle(strCatTitle);
		}

		EditCatTabLabel(i, strCatTitle);
	}

	EMULE_CATCH
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//	UpdateDownloadHeader() updates the information displayed in the right side of the DownloadList rollup bar
void CTransferWnd::UpdateDownloadHeader()
{
	EMULE_TRY

	CString strBuffer;

	strBuffer.Format( GetResString(IDS_RUP_DOWNINFO),
					g_App.m_pDownloadQueue->GetFileCount(),
					g_App.m_pDownloadQueue->GetActiveFileCount(),
					g_App.m_pDownloadQueue->GetPausedFileCount(),
					g_App.m_pDownloadQueue->GetStoppedFileCount(),
					g_App.m_pDownloadQueue->GetTransferringFiles(),
					static_cast<double>(g_App.m_pDownloadQueue->GetDataRate())/1024.0 );
	m_ctlRollup.SetText(0, strBuffer);

	EMULE_CATCH
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//	UpdateUploadHeader() updates the information displayed in the right side of the UploadList rollup bar
void CTransferWnd::UpdateUploadHeader()
{
	EMULE_TRY

	CString strBuffer;

	strBuffer.Format( GetResString(IDS_RUP_UPINFO),
					  g_App.m_pUploadQueue->GetWaitingUserCount(),
						g_App.m_pUploadQueue->GetUploadQueueLength(),
							g_App.m_pUploadQueue->GetBanCount(),
								static_cast<double>(g_App.m_pUploadQueue->GetDataRate())/1024.0);
	m_ctlRollup.SetText(1, strBuffer);

	EMULE_CATCH
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//	UpdateInfoHeader() updates the information displayed in the right side of the InfoList rollup bar
void CTransferWnd::UpdateInfoHeader()
{
	EMULE_TRY

	CString strInfoHeader = _T("");

	switch (m_ctlInfoList.GetType())
	{
		case INFOLISTTYPE_SOURCE:
			strInfoHeader.Format(GetResString(IDS_RUP_INFOUSER), m_ctlInfoList.GetName());
			break;
		case INFOLISTTYPE_FILE:
			strInfoHeader.Format(GetResString(IDS_RUP_INFOFILE), m_ctlInfoList.GetName());
			break;
	}

	m_ctlRollup.SetText(2, strInfoHeader);

	EMULE_CATCH
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CTransferWnd::InitRollupItemHeights()
{
	static const double s_afDefItemHeights[3][8] =
	{
		{ 0, 100, 0, 70, 0, 70, 0, 50 },
		{ 0, 0, 100, 30, 0, 0, 70, 25 },
		{ 0, 0, 0, 0, 100, 30, 30, 25 }
	};

	EMULE_TRY

	double fItemHeights[3][8];
	double (*pafItemHeights)[8];

	FILE *f;
	CString fullpath;

	//
	//	Try to open the GUI settings save file
	fullpath.Format(_T("%sgui.dat"), g_App.m_pPrefs->GetConfigDir());
	f = _tfopen(fullpath, _T("rb"));

	bool bUseDefault = false;

	//	If we opened it...
	if(f)
	{
		TCHAR cTemp[512];
		TCHAR *pToken;
		static const TCHAR s_acSeps[] = _T("|\n");

		for(int exp = 0; exp < 8; exp++)
		{
		//	Try to read a line from the file. If we can't...
			if(!_fgetts(cTemp, 512, f))
			{
				bUseDefault = true;
				break;
			}

			double fTotalHeight = 0.0;

			//	Look for the next seperator
			pToken = _tcstok(cTemp, s_acSeps);
			for(int i = 0; i < 3; i++)
			{
			//	If we couldn't find the expected seperator
				if(!pToken)
				{
					bUseDefault = true;
					break;
				}

			//	Extract the next percentage
				fItemHeights[i][exp] = _tstof(pToken);
//				TRACE("fItemHeights[%d][%d] = %f\r\n", i, exp, _tstof(pToken));
			//	Find the next seperator
				pToken = _tcstok(NULL, s_acSeps);

			//	If we somehow read a negative percentage...
				if(fItemHeights[i][exp] < 0)	// this should never happen
				{
					bUseDefault = true;
					break;
				}
			//	Total up the percentages for this expansion pattern
				fTotalHeight += fItemHeights[i][exp];
			}
			if (bUseDefault)
				break;

			//	If the percentages don't total up to 100 somehow...
			if(fTotalHeight >= 101 || fTotalHeight <= 99 && fTotalHeight != 0) // i'm very tolerant ;)
			{
				bUseDefault = true;
				break;
			}
		}

	//
	//	Restore the user's last expansion state
	//

	//	Try to read the next line
		if(!_fgetts(cTemp, 512, f))
			bUseDefault = true;

		if(!bUseDefault)
		{
			pToken = _tcstok(cTemp, s_acSeps);

			for(int i = 0; i < 3; i++)
			{
				if(!pToken)
				{
					bUseDefault = true;
					break;
				}

				m_ctlRollup.ExpandItem(i, _tstoi(pToken));
				pToken = _tcstok(NULL, s_acSeps);
			}
		}

		fclose(f);
	}
	//	If there are no saved GUI settings...
	else
		bUseDefault = true;

	pafItemHeights = (bUseDefault) ? (double (*)[8])s_afDefItemHeights : fItemHeights;

	m_ctlRollup.SetItemHeights(0, pafItemHeights[0], 8);
	m_ctlRollup.SetItemHeights(1, pafItemHeights[1], 8);
	m_ctlRollup.SetItemHeights(2, pafItemHeights[2], 8);

	EMULE_CATCH
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CTransferWnd::SaveRollupItemHeights()
{
	EMULE_TRY

//	Don't try to save if objects weren't created
	if (m_ctlRollup.GetCount() >= 3)
	{
		FILE *f;
		CString fullpath;

		fullpath.Format(_T("%sgui.dat"), g_App.m_pPrefs->GetConfigDir());
		f = _tfopen(fullpath, _T("wb"));

		if(f)
		{
			for(int exp = 0; exp < 8; exp++)
			{
				double f1,f2,f3;

				f1 = m_ctlRollup.GetItem(0)->pSizes[exp];
				f2 = m_ctlRollup.GetItem(1)->pSizes[exp];
				f3 = m_ctlRollup.GetItem(2)->pSizes[exp];

				// get rid off some rounding errors: ///
				if(f3)
					f3 = f1 ? (f2 ? (100 - f1 - f2) : (100 - f1)) : (100 - f2);
				else if(f2)
					f2 = 100 - f1;
				////////////////////////////////////////

				fprintf(f, "%f|%f|%f\n", f1, f2, f3);
			}
			fprintf( f, "%u|%u|%u\n",
					m_ctlRollup.GetItem(0)->pHeader->IsExpanded(),
					m_ctlRollup.GetItem(1)->pHeader->IsExpanded(),
					m_ctlRollup.GetItem(2)->pHeader->IsExpanded() );
			fclose(f);
		}
	}

	EMULE_CATCH
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
BOOL CTransferWnd::OnCommand(WPARAM wParam, LPARAM lParam)
{
	if (wParam >= MP_CAT_SET_0 && wParam <= MP_CAT_SET_LAST)
	{
		EnumCategories		eCatID = static_cast<_EnumCategories>(static_cast<int>(CAT_PREDEFINED) + (wParam - MP_CAT_SET_0));

		CCat::SetAllCatType(eCatID);
		m_nLastCatTT = -1;
		m_ctlDLTabs.SetCurSel(0);
		m_ctlDownloadList.ChangeCategoryByIndex(0);
		if (eCatID == CAT_ALL)
			EditCatTabLabel(0, CCat::GetPredefinedCatTitle(CCat::GetAllCatType()));
		else
			EditCatTabLabel(0, _T("[")+CCat::GetPredefinedCatTitle(CCat::GetAllCatType())+_T("]"));
		return TRUE;
	}
	if (wParam >= MP_SHOWPREDEFINEDCAT_0 && wParam <= MP_SHOWPREDEFINEDCAT_LAST)
	{
		byte				iCatPos = wParam - MP_SHOWPREDEFINEDCAT_0;
		EnumCategories		eCatID = static_cast<_EnumCategories>(iCatPos + static_cast<int>(CAT_PREDEFINED));
		int					iCatIndex = CCat::GetCatIndexByID(eCatID);

	//	If the predefined cat isn't in...
		if (iCatIndex == -1)
		{
			AddPredefinedCategory(eCatID);
			g_App.m_pPrefs->SaveCats();
		}
		else
		{
			m_nLastCatTT = -1;
			CCat::RemoveCatByIndex(iCatIndex);
			m_ctlDLTabs.DeleteItem(iCatIndex);
			m_ctlDLTabs.SetCurSel(0);
			m_ctlDownloadList.ChangeCategoryByID(CAT_ALL);
			g_App.m_pPrefs->SaveCats();
		}
		UpdateCatTabTitles();
		return TRUE;
	}

	switch (wParam)
	{
		case USRMSG_SWITCHUPLOADLIST:
			SwitchUploadList();
			break;

		case USRMSG_CLEARCOMPLETED:
			g_App.m_pDownloadList->ClearCompleted(CAT_NONE);
			break;

		case MP_CAT_ADD:
		{
			m_nLastCatTT = -1;
			int newindex = AddCategory("?", g_App.m_pPrefs->GetIncomingDir(), g_App.m_pPrefs->GetTempDir(), "", "", true);
			CCatDialog dialog(newindex);

			if (dialog.DoModal() == IDCANCEL)
			{
				CCat::RemoveCatByIndex(newindex);
				m_ctlDLTabs.DeleteItem(newindex);
				m_ctlDLTabs.SetCurSel(0);
				m_ctlDownloadList.ChangeCategoryByIndex(0);
				g_App.m_pPrefs->SaveCats();
				if (CCat::GetNumCats() == 1)
				{
					CCat::SetAllCatType(CAT_ALL);
				}
				g_App.m_pMDlg->m_dlgSearch.UpdateCatTabs();
			}
			else
			{
				g_App.m_pMDlg->m_dlgSearch.UpdateCatTabs();
				EditCatTabLabel(newindex, CCat::GetCatByIndex(newindex)->GetTitle());
				g_App.m_pPrefs->SaveCats();
			}
			break;
		}

		case MP_CAT_EDIT:
		{
			m_nLastCatTT = -1;

			CCatDialog		dialog(m_iTabRightClickIndex);

			dialog.DoModal();

			CString csName = CCat::GetCatByIndex(m_iTabRightClickIndex)->GetTitle();

			EditCatTabLabel(m_iTabRightClickIndex, csName);
			g_App.m_pMDlg->m_dlgSearch.UpdateCatTabs();
			g_App.m_pPrefs->SaveCats();
			break;
		}
		case MP_CAT_REMOVE:
		{
			m_nLastCatTT = -1;
			g_App.m_pDownloadQueue->ResetCatParts(m_iTabRightClickIndex);
			CCat::RemoveCatByIndex(m_iTabRightClickIndex);
			m_ctlDLTabs.DeleteItem(m_iTabRightClickIndex);
			m_ctlDLTabs.SetCurSel(0);
			m_ctlDownloadList.ChangeCategoryByID(CAT_ALL);
			g_App.m_pPrefs->SaveCats();
			if (CCat::GetNumCats() == 1)
			{
				CCat::SetAllCatType(CAT_ALL);
			}
			g_App.m_pMDlg->m_dlgSearch.UpdateCatTabs();
			break;
		}
		case MP_PRIOLOW:
		{
			g_App.m_pDownloadQueue->SetCatPrio(m_iTabRightClickIndex,PR_LOW);
			break;
		}
		case MP_PRIONORMAL:
		{
			g_App.m_pDownloadQueue->SetCatPrio(m_iTabRightClickIndex,PR_NORMAL);
			break;
		}
		case MP_PRIOHIGH:
		{
			g_App.m_pDownloadQueue->SetCatPrio(m_iTabRightClickIndex,PR_HIGH);
			break;
		}
		case MP_PRIOAUTO:
		{
			g_App.m_pDownloadQueue->SetCatPrio(m_iTabRightClickIndex,PR_AUTO);
			break;
		}
		case MP_PAUSE:
		{
			g_App.m_pDownloadQueue->SetCatStatus(m_iTabRightClickIndex,MP_PAUSE);
			break;
		}
		case MP_STOP:
		{
			g_App.m_pDownloadQueue->SetCatStatus(m_iTabRightClickIndex,MP_STOP);
			break;
		}
		case MP_CANCEL:
		{
			if (AfxMessageBox(GetResString(IDS_Q_CANCELDL),MB_ICONQUESTION|MB_YESNO) == IDYES)
			{
				g_App.m_pDownloadQueue->SetCatStatus(m_iTabRightClickIndex,MP_CANCEL);
			}
			break;
		}
		case MP_RESUME:
		{
			g_App.m_pDownloadQueue->SetCatStatus(m_iTabRightClickIndex,MP_RESUME);
			break;
		}
		case MP_RESUMENEXT:
		{
			g_App.m_pDownloadQueue->StartNextFile(CCat::GetCatIDByIndex(m_iTabRightClickIndex));
			break;
		}
		default:
			break;
	}

	return CResizableDialog::OnCommand(wParam, lParam);
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//	GetTabUnderMouse() returns the index of the category tab at point 'point' or -1 if there is none.
int CTransferWnd::GetTabUnderMouse(CPoint* point)
{
	TCHITTESTINFO hitinfo;
	CRect rect;

	m_ctlDLTabs.GetWindowRect(&rect);
	point->Offset(0-rect.left,0-rect.top);
	hitinfo.pt = *point;

	if(m_ctlDLTabs.GetItemRect( 0, &rect ))
	{
		if(hitinfo.pt.y< rect.top+30 && hitinfo.pt.y >rect.top-30)
		{
			hitinfo.pt.y = rect.top;
		}
	}

	// Find the destination tab...
	unsigned int		nTab = m_ctlDLTabs.HitTest(&hitinfo);

	if (hitinfo.flags != TCHT_NOWHERE)
		return nTab;
	else
		return -1;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//	OnTcnSelchangeDltab() is the message handler for selection changes in the category tab
void CTransferWnd::OnTcnSelchangeDltab(NMHDR *pNMHDR, LRESULT *pResult)
{
	byte		catIndex;

	catIndex = m_ctlDLTabs.GetCurSel();
	m_ctlDownloadList.ChangeCategoryByIndex(catIndex);
	*pResult = 0;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//	OnNMRClickDltab() is the right-click message handler for the tab control.
// Ornis' download categories
void CTransferWnd::OnNMRClickDltab(NMHDR *pNMHDR, LRESULT *pResult)
{
//	Popup menu for the category tabs
	CTitleMenu	menu;
	POINT		point;

	::GetCursorPos(&point);

	CPoint		pt(point);
	CMenu		menuView, menuCat, menuPriority;

	menuPriority.CreateMenu();
	menuPriority.AppendMenu(MF_STRING, MP_PRIOLOW, GetResString(IDS_PRIOLOW));
	menuPriority.AppendMenu(MF_STRING, MP_PRIONORMAL, GetResString(IDS_PRIONORMAL));
	menuPriority.AppendMenu(MF_STRING, MP_PRIOHIGH, GetResString(IDS_PRIOHIGH));
	menuPriority.AppendMenu(MF_STRING, MP_PRIOAUTO, GetResString(IDS_PRIOAUTO));

	menu.CreatePopupMenu();
	menu.AddMenuTitle(GetResString(IDS_CAT));

	m_iTabRightClickIndex = GetTabUnderMouse(&pt);

	if (m_iTabRightClickIndex == 0)
	{
		menuView.CreateMenu();
		menuView.AppendMenu(MF_STRING,MP_CAT_SET_0,GetResString(IDS_CAT_ALL));
		menuView.AppendMenu(MF_STRING,MP_CAT_SET_0+1,GetResString(IDS_CAT_UNCATEGORIZED));
		menuView.AppendMenu(MF_SEPARATOR);
		menuView.AppendMenu(MF_STRING,MP_CAT_SET_0+2,GetResString(IDS_CAT_INCOMPLETE));
		menuView.AppendMenu(MF_STRING,MP_CAT_SET_0+3,GetResString(IDS_CAT_COMPLETED));
		menuView.AppendMenu(MF_STRING,MP_CAT_SET_0+4,GetResString(IDS_CAT_WAITING));
		menuView.AppendMenu(MF_STRING,MP_CAT_SET_0+5,GetResString(IDS_CAT_DOWNLOADING));
		menuView.AppendMenu(MF_STRING,MP_CAT_SET_0+6,GetResString(IDS_CAT_ERRONEOUS));
		menuView.AppendMenu(MF_STRING,MP_CAT_SET_0+7,GetResString(IDS_CAT_PAUSED));
		menuView.AppendMenu(MF_STRING,MP_CAT_SET_0+8,GetResString(IDS_CAT_STOPPED));
		menuView.AppendMenu(MF_STRING,MP_CAT_SET_0+9,GetResString(IDS_CAT_STALLED));
		menuView.AppendMenu(MF_STRING,MP_CAT_SET_0+10,GetResString(IDS_CAT_ACTIVE));
		menuView.AppendMenu(MF_STRING,MP_CAT_SET_0+11,GetResString(IDS_CAT_INACTIVE));
		menuView.AppendMenu(MF_SEPARATOR);
		menuView.AppendMenu(MF_STRING,MP_CAT_SET_0+12,GetResString(IDS_CAT_VIDEO));
		menuView.AppendMenu(MF_STRING,MP_CAT_SET_0+13,GetResString(IDS_CAT_AUDIO));
		menuView.AppendMenu(MF_STRING,MP_CAT_SET_0+14,GetResString(IDS_CAT_ARCHIVES));
		menuView.AppendMenu(MF_STRING,MP_CAT_SET_0+15,GetResString(IDS_CAT_CDIMAGES));

		menuView.CheckMenuItem(MP_CAT_SET_0 + CCat::GetAllCatType() - CAT_PREDEFINED, MF_CHECKED | MF_BYCOMMAND);

		menu.AppendMenu(MF_STRING|MF_POPUP,(UINT_PTR)menuView.m_hMenu, GetResString(IDS_CHANGECATVIEW));
	}

	int			iNumPredefinedCats = CCat::GetNumPredefinedCats();
	UINT		dwPredefinedCatActionFlag = (m_iTabRightClickIndex < iNumPredefinedCats) ? MF_GRAYED : MF_STRING;
	UINT		dwIsAllOrUserFlag = ((m_iTabRightClickIndex < iNumPredefinedCats) && !(m_iTabRightClickIndex == 0 && CCat::GetAllCatType() == CAT_ALL))? MF_GRAYED : MF_STRING;

	if (m_iTabRightClickIndex < iNumPredefinedCats)
	{
		menuCat.CreateMenu();
		for (int i = 0; i < CAT_TOTALPREDEFINEDCATS; i++)
		{
		//	Check to see if the cat has a tab and check the menu item if so
			int		catIndex = CCat::GetCatIndexByID(static_cast<_EnumCategories>(static_cast<int>(CAT_PREDEFINED) + i));
			UINT	checkFlag = (catIndex == -1) ? MF_UNCHECKED : MF_CHECKED;

			if (i == 0)
				checkFlag |= MF_GRAYED;

		//	Add the 'i'th predefined category title
			menuCat.AppendMenu( MF_STRING | checkFlag,
								  MP_SHOWPREDEFINEDCAT_0 + i,
								  CCat::GetPredefinedCatTitle(static_cast<_EnumCategories>(static_cast<int>(CAT_PREDEFINED) + i)) );

		//	Add a seperator after the last of the status categories.
			if (CAT_PREDEFINED + i == CAT_LASTSTATUSCAT)
			{
				menuCat.AppendMenu(MF_SEPARATOR);
			}
		}
		menu.AppendMenu(MF_STRING|MF_POPUP,(UINT_PTR)menuCat.m_hMenu, GetResString(IDS_CAT_SHOWSTATUSTAB));
		menu.AppendMenu(MF_SEPARATOR);
	}

	menu.AppendMenu(MF_STRING,MP_CAT_ADD,GetResString(IDS_CAT_ADD));
	menu.AppendMenu(dwPredefinedCatActionFlag, MP_CAT_EDIT, GetResString(IDS_CAT_EDIT));
	menu.AppendMenu(dwPredefinedCatActionFlag, MP_CAT_REMOVE, GetResString(IDS_CAT_REMOVE));
	menu.AppendMenu(MF_SEPARATOR);
	menu.AppendMenu(dwIsAllOrUserFlag|MF_POPUP, (UINT_PTR)menuPriority.m_hMenu, GetResString(IDS_PRIORITY));

	menu.AppendMenu(MF_STRING,MP_CANCEL,GetResString(IDS_MAIN_BTN_CANCEL));
	menu.AppendMenu(MF_STRING,MP_STOP, GetResString(IDS_STOP_VERB));
	menu.AppendMenu(MF_STRING,MP_PAUSE, GetResString(IDS_PAUSE_VERB));
	menu.AppendMenu(MF_STRING,MP_RESUME, GetResString(IDS_RESUME));
	menu.AppendMenu(MF_STRING,MP_RESUMENEXT, GetResString(IDS_DL_RESUMENEXT));

	menu.TrackPopupMenuEx(TPM_LEFTALIGN | TPM_RIGHTBUTTON, point.x, point.y, this, NULL);

//	Menu objects are destroyed in their destructor

	*pResult = 0;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CTransferWnd::OnLvnBeginDrag(NMHDR *pNMHDR, LRESULT *pResult)
{
	int iSel = m_ctlDownloadList.GetSelectionMark();

	if (iSel == -1)
		return;

	CMuleCtrlItem	   *pItem = reinterpret_cast<CMuleCtrlItem*>(m_ctlDownloadList.GetItemData(iSel));
	CPartFileDLItem	   *pFileItem = dynamic_cast<CPartFileDLItem*>(pItem);

	if (pFileItem == NULL)
		return;

	m_bIsDragging = true;

	POINT pt;

	::GetCursorPos(&pt);

	LPNMLISTVIEW pNMLV = reinterpret_cast<LPNMLISTVIEW>(pNMHDR);

	m_nDragIndex = pNMLV->iItem;
	m_pDragImage = m_ctlDownloadList.CreateDragImage(m_ctlDownloadList.GetSelectionMark(),&pt);
    m_pDragImage->BeginDrag(0, CPoint(0,0));
    m_pDragImage->DragEnter(GetDesktopWindow(), pNMLV->ptAction);
    SetCapture();
	m_nTabDropIndex = -1;

	*pResult = 0;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CTransferWnd::OnMouseMove(UINT nFlags, CPoint point)
{
	if(!(nFlags & MK_LBUTTON))
		m_bIsDragging = false;


	if(m_bIsDragging)
	{
		CPoint pt(point);           //get our current mouse coordinates

		ClientToScreen(&pt);        //convert to screen coordinates

		m_nTabDropIndex = GetTabUnderMouse(&pt);
		m_ctlDLTabs.SetCurSel(m_nTabDropIndex);
		m_ctlDLTabs.Invalidate();

		::GetCursorPos(&pt);
		pt.y -= 10;

		m_pDragImage->DragMove(pt); //move the drag image to those coordinates
	}
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CTransferWnd::OnLButtonUp(UINT iFlags, CPoint point)
{
	if (m_bIsDragging)
	{
		ReleaseCapture();
		m_bIsDragging = false;

		m_pDragImage->DragLeave(GetDesktopWindow());
		m_pDragImage->EndDrag();
		delete m_pDragImage;

	//	If the cursor is over a tab and the current tab is a predefined cat
		if ( m_nTabDropIndex >= CCat::GetNumPredefinedCats()
		 && ( m_ctlDownloadList.GetCurTabIndex() < CCat::GetNumPredefinedCats()
		   || ( m_ctlDownloadList.GetCurTabIndex() >= CCat::GetNumPredefinedCats()
		     && m_nTabDropIndex != m_ctlDownloadList.GetCurTabIndex()) ) )
		{
			CPartFile	   *pPartFile;
			int				index = -1;
			POSITION		pos = m_ctlDownloadList.GetFirstSelectedItemPosition();

			while (pos != NULL)
			{
				index = m_ctlDownloadList.GetNextSelectedItem(pos);
				if (index > -1)
				{
					CMuleCtrlItem	*pItem = reinterpret_cast<CMuleCtrlItem*>(m_ctlDownloadList.GetItemData(index));
					CPartFileDLItem	*pFileItem = dynamic_cast<CPartFileDLItem*>(pItem);

					if (pFileItem != NULL)
					{
						pPartFile = pFileItem->GetFile();
						pPartFile->SetCatID(CCat::GetCatIDByIndex(m_nTabDropIndex));
					}
				}
			}

			m_ctlDLTabs.SetCurSel(m_ctlDownloadList.GetCurTabIndex());

			//if (m_ctlDLTabs.GetCurSel() > CCat::GetNumPredefinedCats())
			m_ctlDownloadList.ChangeCategoryByIndex(m_ctlDLTabs.GetCurSel());

			UpdateCatTabTitles();
		}
		else
		{
			m_ctlDLTabs.SetCurSel(m_ctlDownloadList.GetCurTabIndex());
		}
		m_ctlDownloadList.Invalidate();
	}
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CTransferWnd::OnDblClickDltab()
{
	CPoint	point;

	::GetCursorPos(&point);

	int		iTab = GetTabUnderMouse(&point);

	if (iTab >= CCat::GetNumPredefinedCats())
	{
		m_iTabRightClickIndex = iTab;
		OnCommand(MP_CAT_EDIT, 0);
	}
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//	UpdateCatTabTitles() updates the tab text to reflect the current category titles and, incidentally,
//		updates the file count information displayed on the tab.
void CTransferWnd::UpdateCatTabTitles()
{
	if (!g_App.m_pMDlg->IsRunning())
		return;

	CString		strCatTitle;

//	For each tab...
	for (byte i = 0; i < m_ctlDLTabs.GetItemCount(); i++)
	{
		if (i == 0)
		{
			EnumCategories		eCatID = CCat::GetAllCatType();

			strCatTitle = CCat::GetPredefinedCatTitle(eCatID);
			if (eCatID != CAT_ALL)
			{
				strCatTitle = _T('[') + strCatTitle;
				strCatTitle += _T(']');
			}
		}
		else
		{
			strCatTitle = CCat::GetCatByIndex(i)->GetTitle();
		}
	//	If it's the "All" tab change the title to reflect the current All category selection.
	//	If not, change the title to reflect the current category title
		EditCatTabLabel(i, strCatTitle);
	}
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//	EditCatTabLabel() changes the label of tab 'index' to 'strNewLabel' (with additional file count info if the
//		"Show Category Tab Info" preference is set)
void CTransferWnd::EditCatTabLabel(int index, CString strNewLabel)
{
	TCITEM tabitem;

	tabitem.mask = TCIF_PARAM;
	m_ctlDLTabs.GetItem(index,&tabitem);
	tabitem.mask = TCIF_TEXT;

	CDownloadList::PartFileVector  *pvecPartFiles;
	uint32							dwTotalCount = 0;
	uint32							dwDownloading = 0;

//	Count the number of files in the DownloadQueue belonging to the
//	'index'th category and the number of those currently downloading
	if ((pvecPartFiles = g_App.m_pDownloadList->GetFiles()) != NULL)
	{
		for(unsigned int i = 0; i < pvecPartFiles->size(); i++)
		{
			CPartFile		*pPartFile = (*pvecPartFiles)[i];

			if (pPartFile == NULL)
				continue;

			if (CCat::FileBelongsToGivenCat(pPartFile,CCat::GetCatIDByIndex(index)))
			{
				dwTotalCount++;
				if(pPartFile->GetTransferringSrcCount() > 0)
					dwDownloading++;
			}
		}
	}

	delete pvecPartFiles;
	pvecPartFiles = NULL;

//	Append the appropriate information to the tab label

//	KuSh: what about not displaying dwDownloading if null ?
	if (!CCat::GetCatByIndex(index)->IsPredefined()/* && dwDownloading > 0*/)
	{
		strNewLabel.AppendFormat(_T(" %u/%u"), dwDownloading, dwTotalCount);
	}
	else
	{
	//	We don't really need a download count on predefined cats
		strNewLabel.AppendFormat(_T(" %u"), dwTotalCount);
	}

	tabitem.pszText = strNewLabel.LockBuffer();
	m_ctlDLTabs.SetItem(index,&tabitem);
	strNewLabel.UnlockBuffer();
	m_ctlDLTabs.Invalidate();
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
int CTransferWnd::AddCategory( CString strNewTitle, CString strNewIncoming, CString strNewTemp, 
							   CString strNewComment, CString strNewAutoCatExt, bool bAddTab)
{
	CCat		*pNewCat = new CCat(strNewTitle, strNewIncoming, strNewTemp, strNewComment, strNewAutoCatExt);

	int		iIndex = CCat::AddCat(pNewCat);

	if (bAddTab)
		m_ctlDLTabs.InsertItem(iIndex,strNewTitle);

	m_ctlDLTabs.Invalidate();

	return iIndex;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
int CTransferWnd::AddPredefinedCategory(EnumCategories ePredefinedCatID, bool bAddTab/*=true*/)
{
	CCat	*pNewCat = new CCat(ePredefinedCatID);

	int		iIndex = CCat::AddPredefinedCat(pNewCat);

	if (bAddTab)
		m_ctlDLTabs.InsertItem(iIndex, pNewCat->GetTitle());

	m_ctlDLTabs.Invalidate();

	return iIndex;
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void CTransferWnd::OnTabMovement(NMHDR *pNMHDR, LRESULT *pResult)
{
	UINT	from = m_ctlDLTabs.GetLastMovementSource();
	UINT	to = m_ctlDLTabs.GetLastMovementDestination();
	byte	iNumPredefinedCats = CCat::GetNumPredefinedCats();

	if (from < iNumPredefinedCats || to < iNumPredefinedCats || from == to-1)
		return;
//
//	Do the reorder
//

//	Rearrange the cat-map
	if (!CCat::MoveCat(from,to))
		return;

//	Rearrange the tab control itself
	m_ctlDLTabs.ReorderTab(from,to);

	UpdateCatTabTitles();
	g_App.m_pMDlg->m_dlgSearch.UpdateCatTabs();

	if (to > from)
	{
		--to;
	}
	m_ctlDLTabs.SetCurSel(to);
	m_ctlDownloadList.ChangeCategoryByIndex(to);
	m_ctlDLTabs.Invalidate();
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
BOOL CTransferWnd::OnNotify(WPARAM wParam, LPARAM lParam, LRESULT* pResult)
{
	NMHDR* pNMHDR = (NMHDR*)lParam;

	if (pNMHDR->hwndFrom == m_ctlDLTabs.GetSafeHwnd())
	{
		switch(pNMHDR->code)
		{
			case NM_RCLICK:
				OnNMRClickDltab(pNMHDR, pResult);
				break;
			case NM_DBLCLK:
			case WM_LBUTTONDBLCLK:
				OnDblClickDltab();
				break;
			case TCN_SELCHANGE:
				OnTcnSelchangeDltab(pNMHDR, pResult);
				break;
			case NM_TABMOVED:
				OnTabMovement(pNMHDR, pResult);
				break;
		}
	}
	else if(pNMHDR->hwndFrom == m_ctlDownloadList.GetSafeHwnd())
	{
		switch(pNMHDR->code)
		{
			case LVN_BEGINDRAG:
				OnLvnBeginDrag(pNMHDR, pResult);
				break;
		}
	}
	else
	{
		switch(pNMHDR->code)
		{
			case UDM_TOOLTIP_DISPLAY:
			{
				NM_PPTOOLTIP_DISPLAY *pNotify = (NM_PPTOOLTIP_DISPLAY*)lParam;

				GetInfo4ToolTip(pNotify);
				return TRUE;
			}
			case UDM_TOOLTIP_POP:
			{
				m_ttip.Pop();
				return TRUE;
			}
		}
	}

	return CResizableDialog::OnNotify(wParam, lParam, pResult);
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
